/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 178 by dpavlin, Tue Mar 16 15:06:30 2010 UTC revision 190 by root, Tue Mar 16 23:14:38 2010 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /bin/sh
2    ### BEGIN INIT INFO
3  # based on Tony Risinger code from lxc-users  # Provides:          lxc-watchdog
4    # Required-Start:    $remote_fs $named $network $time
5    # Required-Stop:     $remote_fs $named $network
6    # Required-Start:    
7    # Required-Stop:    
8    # Default-Start:     2 3 4 5
9    # Default-Stop:      0 1 6
10    # Short-Description: Manage Linux Containers startup/shutdown
11    # Description:       Uses clever inotify hack to monitor container's
12    #                    halt/reboot events watching /var/run/utmp
13    ### END INIT INFO
14    
15    # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
16    #
17    # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
26    
 name=$1  
27    
28  if [ ! -e /var/lib/lxc/$name/config ] ; then  lxc_exists() {
29          echo "Usage: $0 name"          name=$1
30          ls /var/lib/lxc/*/config | cut -d/ -f5  
31          exit 1          if [ ! -e /var/lib/lxc/$name/config ] ; then
32  fi                  echo "Usage: $0 name"
33                    lxc_status
34                    exit 1
35            fi
36    }
37    
 rootfs=`grep lxc.rootfs /var/lib/lxc/$name/config | cut -d= -f2`  
 echo "$name rootfs $rootfs"  
38    
39  # cleanup init scripts which don't work in containers  lxc_rootfs() {
40  ls $rootfs/etc/rc?.d/*umountfs 2>/dev/null | xargs -i rm -v {}          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41  ls $rootfs/etc/rc?.d/*umountroot 2>/dev/null | xargs -i rm -v {}  }
42  ls $rootfs/etc/rc?.d/*hwclock* 2>/dev/null | xargs -i rm -v {}  
43    
44    lxc_status() {
45            lxc-ls -1 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
46                    boot="    "
47                    test -s /var/lib/lxc/$name/on_boot && boot="boot"
48                    echo "$name $status $boot $(lxc_rootfs $name)"
49            done
50    }
51    
52    
53    cleanup_init_scripts() {
54            rootfs=$(lxc_rootfs $1)
55    
56            ls \
57                    $rootfs/etc/rc?.d/*umountfs \
58                    $rootfs/etc/rc?.d/*umountroot \
59                    $rootfs/etc/rc?.d/*hwclock* \
60            2>/dev/null | xargs -i rm -v {}
61    }
62    
63    
64    setup_inittab() {
65            rootfs=$(lxc_rootfs $1)
66            remove=$2
67            add=$3
68    
69            # let container respond to kill -SIGPWR
70            inittab=$rootfs/etc/inittab
71            if ! grep "$add" ${inittab} >/dev/null ; then
72                    grep -v "$remove" ${inittab} > ${inittab}.new
73                    echo $add >> ${inittab}.new
74                    mv ${inittab}.new ${inittab}
75                    echo "$inittab modified with $add"
76            fi
77    }
78    
79    
80    lxc_log() {
81            echo `date +%Y-%m-%dT%H:%M:%S` $*
82    }
83    
84    
85    lxc_kill() {
86            name=$1
87            sig=$2
88    
89            init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
90            if [ -z "$init_pid" ] ; then
91                    lxc-info -n $name
92                    exit 1
93            fi
94            lxc_log "$name kill $sig $init_pid"
95            /bin/kill $sig $init_pid
96    }
97    
98    lxc_stop() {
99            lxc_log "$name stop"
100            lxc_kill $name -SIGPWR
101            lxc-wait -n $name -s STOPPED
102            lxc_log "$name stoped"
103    #       rm -f /var/lib/lxc/${name}/on_boot
104    }
105    
106    
107    lxc_start() {
108            name=$1
109    
110            if ! lxc-info -n $name | grep RUNNING ; then
111                    lxc_log "$name start"
112                    lxc-start -n $name -o /tmp/${name}.log -d
113                    lxc-wait  -n $name -s RUNNING
114                    lxc-info  -n $name
115                    test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
116            fi
117    }
118    
119  lxc-info -n $name | grep RUNNING || lxc-start -d -n $name -o /tmp/${name}.log && echo "$name start"  lxc_watchdog() {
120    name=$1
121    rootfs=$(lxc_rootfs $1)
122    
123  while true; do  while true; do
         # time of 5 minutes on it JUST IN CASE...  
124          vps_utmp=${rootfs}/var/run/utmp          vps_utmp=${rootfs}/var/run/utmp
125          inotifywait -qqt 300 ${vps_utmp}          tasks=`wc -l < /cgroup/${name}/tasks`
126          if [ $(wc -l < /cgroup/${name}/tasks) -eq 1 ]; then          test -z "$tasks" && exit 1
127            if [ "$tasks" -eq 1 ]; then
128    
129                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel ${vps_utmp})"
130                  echo "# $name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
131    
132                  case $runlevel in                  case $runlevel in
133                  N*)                  N*)
134                          # nothing for new boot state                          # nothing for new boot state
135                  ;;                  ;;
136                  ??0)                  ??0)
137                          echo "$name halt"                          lxc_log "$name halt"
138                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
139                            lxc-wait -n ${name} -s STOPPED
140                          break                          break
141                  ;;                  ;;
142                  ??6)                  ??6)
143                          echo "$name reboot";                          lxc_log "$name reboot";
144                          lxc-stop -n ${name}                          lxc-stop -n ${name}
145                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
                         mount /mnt/llin -o remount,rw  
146                          lxc-start -d -n ${name} -o /tmp/${name}.log                          lxc-start -d -n ${name} -o /tmp/${name}.log
147                  ;;                  ;;
148                  *)                  *)
# Line 54  while true; do Line 151  while true; do
151                          [ "$state" = "RUNNING" ] || break                          [ "$state" = "RUNNING" ] || break
152                  ;;                  ;;
153                  esac                  esac
154            else
155                    lxc_log "$name $tasks tasks"
156          fi          fi
157    
158            # time of 5 minutes on it JUST IN CASE...
159            inotifywait -qqt 300 ${vps_utmp}
160  done  done
161    
162    lxc_log "$name watchdog exited"
163    
164    }
165    
166    
167    usage() {
168            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
169            exit 3
170    }
171    
172    command_on_lxc() {
173    command=$1
174    shift
175    
176    echo "# $command $1"
177    
178    case "$command" in
179    
180    start)
181            lxc_exists $1
182            cleanup_init_scripts $1
183            setup_inittab $1 ::power      "p0::powerfail:/sbin/init 0"
184            setup_inittab $1 ::ctrlaltdel "p6::ctrlaltdel:/sbin/init 6"
185            lxc_start $1
186            # give container 5 seconds to start more than one process
187            ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
188            ;;
189    stop|halt)
190            lxc_exists $1
191            lxc_stop $1
192            ;;
193    reload|force-reload|restart|reboot)
194            lxc_kill $1 -SIGINT
195            ;;
196    watchdog)
197            lxc_watchdog $1
198            ;;
199    boot)
200            echo $1 > /var/lib/lxc/$1/on_boot
201            ;;
202    disable)
203            echo -n > /var/lib/lxc/$1/on_boot
204            ;;
205    *)
206            usage
207            ;;
208    
209    esac
210    
211    }
212    
213    command=$1
214    test -z "$command" && usage
215    test "$command" = "status" && lxc_status && exit
216    shift
217    
218    if [ -z "$1" ] ; then
219            ls /var/lib/lxc/*/on_boot | while read path ; do
220                    name=`echo $path | cut -d/ -f5`
221                    if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
222                            command_on_lxc $command $name
223                    else
224                            echo "# skip $command $name"
225                    fi
226            done
227    else
228            while [ ! -z "$1" ] ; do
229                    command_on_lxc $command $1
230                    shift
231            done
232    fi
233    

Legend:
Removed from v.178  
changed lines
  Added in v.190

  ViewVC Help
Powered by ViewVC 1.1.26